
//#include "../buffer_module/DList.h"
/*
typedef struct _SESSION
{
	int myDlgID;
	char * FID;
	int urDlgID;
}SESSION, *LPSESION;
*/

//SESSION ospSession;

#include "osp_socket.h"

#define SESSION_MAX_SIZE 100

#define SES_RECORDNOTFOUND		-2
#define SES_BUFFEREMPTY			-1
#define SES_BUFFERFULL			0
#define SES_INSERTED			1
#define SES_RECORDFOUND			2

struct Session_Record
{
	HWND	hCDlg;
	int		myDlgID;
	char	FID[SID_SIZE];
	int		fdDlgID;
	HWND	hChatList;
	int		state;

	Session_Record()
	{
		hCDlg=(HWND)1;
		hChatList=(HWND)1;
		myDlgID=1;
		fdDlgID=1;
		state=0;
	};

	Session_Record &operator =(const Session_Record & node)
	{
		hCDlg=node.hCDlg;
		myDlgID=node.myDlgID;
		strcpy(FID,node.FID);
		fdDlgID=node.fdDlgID;
		hChatList=node.hChatList;
		state=node.state;
		return *this;
	};
/*	Session_Record  operator =(const Session_Record & node)
	{
		hCDlg=node.hCDlg;
		myDlgID=node.myDlgID;
		strcpy(FID,node.FID);
		fdDlgID=node.fdDlgID;
		return &this;
	}*/
};

class SessionClass
{
	Session_Record ses[SESSION_MAX_SIZE];//
	int count;//
	int findSessionIndex(const char* FriendID);//
//	int findSessionIndex(const int FriendDlgID);//
	int findSessionIndex(const int dlgID);//
	int findSessionIndex(const HWND hdlg);//

public:
	SessionClass();//
	~SessionClass();//

	int insertSession(const Session_Record& SR);//

	int findSession(const int dlgID,Session_Record& SR);//
	int findSession(const char* FriendID, Session_Record& SR);//
	int findSession(const HWND hdlg, Session_Record& SR);//
	
	int deleteSession(const char* FriendID);//
	int deleteSession(const int dlgID);
	
	int modifySession(const int dlgID, const Session_Record& SR);
};
