#ifndef __TRAY_H__
#define __TRAY_H__

#include <windows.h>
#include "../../resource.h"
#define TRAY_NOTIFY (WM_APP + 100)

class Trayicon
{
public:
	NOTIFYICONDATA uid;		//	STRUCTURE
	HMENU Traymenu, Popup;			//	TRAY MENU
	HINSTANCE t_hInst;		//	TRAY HINSTANCE
	HWND t_hWnd;			//	TRAY HWND
	UINT t_uID;				//	TRAY UINT

public:
	//	Constructor
	Trayicon();
	Trayicon(HINSTANCE hInst, HWND hWnd, UINT uID);
	//	Destructor
	~Trayicon();
	//  Initial Tray
	BOOL TrayInit(HINSTANCE hInst, HWND hwnd, UINT uid);
	//	Create Tray
	BOOL CreateIcon(UINT uCallbackMessage, LPCTSTR szToolTip, HICON icon);
	//	Change Tray Icon
	BOOL SetIcon(HICON hIcon);
	//	Change Tray ToolTip
	BOOL SetToolTipText(LPCTSTR pszTip);
	//	Tray Event Process
	BOOL TrayProcess(LPARAM lParam);
	//	Tray Menu Process
	BOOL TrayMenuProcess(WORD);
	//	Tray delete	
	void DeleteIcon();
	//	Tray balloon Help
	// BOOL TrayBalloonHelp();
};

#endif