
#ifndef OSPTREEVIEW_H
#define OSPTREEVIEW_H

//#include "osp_mClass.h"

#include <windows.h>
#include <commctrl.h>

#define OTV_NOT_INIT	0	//Ŭ 
#define OTV_INIT_READY	1	//⺻  ʱȭ
#define OTV_WIND_NOIMG	2	// ʱȭ ȵ ̹ ʱȭ ȵȰ
#define	OTV_INIT_POS	3	//ġ ʱȭ 
#define OTV_USE			4

struct treeNode{
	int iParent;
	char * Title;
	int stateImage;
	
	treeNode& operator=(treeNode & node)
	{
		iParent = node.iParent;
		Title	= node.Title;
		stateImage = node.stateImage;
		return *this;
	}
};


class ospTreeView
{
public: 
	int				use;
private:
	HWND			hParent;
	HINSTANCE		hInst;
//	RECT			Treepos;
	HWND			hTree;
	HIMAGELIST		hImage;
	HTREEITEM		hRoot;
	int				State;

public:
	ospTreeView();//
	ospTreeView(HINSTANCE,HWND);//
	~ospTreeView();//
	void Create();//
	void Create(HINSTANCE,HWND);//
	void InitImage(LPCSTR lpbmp);//
	void SetPos(RECT pos);//
	void SetPos(int left,int top,int right,int bottom);//

	void InsertRoot(char * root);
	void InsertGroup(char * group);//
	void InsertGroup(char * group,int img);//
	void InsertChild(char * child);//
	void InsertChild(char * child,int img);//
	void InsertChild(const char * group, char * child);//
	void InsertChild(const char* group, char* child,int img);
	void InsertChild(HTREEITEM parent,char * child,int img);
	void InsertChild(HTREEITEM , char *);//

	void ModifyGroup(const char * oldName, const char * newName);
	void ModifyChild(const char * oldName, const char * newName);
	void ModifyChild(const HTREEITEM fti,int state);

	void DeleteGroup(const char * group);//
	void DeleteChild(const char * group,const char * child);//
	void DeleteChild(const char * child);
	void DeleteAll();

	HTREEITEM FindGroup(const char * name);
	HTREEITEM FindChild(const char * group,const char * name);
	HTREEITEM FindChild(HTREEITEM, const char *);
	bool FindGroupExist(const char *);
	HTREEITEM FindChildAll(const char * group,const char * name);

	HWND GetTreeHandle();
	bool IsChildNode();
};



#endif