
#include "../osp_mClass.h"
#include <windows.h>            // required for all Windows applications
#include <windowsx.h>

#include "../osp_global.h"            
#include "../osp_win/osp_dispatch.h"

//   Function Definitions

//	Main Callback Fuction
LRESULT CALLBACK addFID(HWND, UINT, WPARAM, LPARAM);

//	Event Function
LRESULT MsgaddFIDInit(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgaddFIDCommand(HWND, UINT, WPARAM, LPARAM);
//LRESULT MsgaddFIDClose(HWND, UINT, WPARAM, LPARAM);

//	Command Function
LRESULT CmdaddFIDOk(HWND, WORD, WORD, HWND);
LRESULT CmdaddFIDCancel(HWND, WORD, WORD, HWND);
LRESULT CmdaddFIDEnableOK(HWND, WORD, WORD, HWND);

// Connect dialog message table definition.
MSD rgmsdaddFID[] =
{
    {WM_COMMAND,        MsgaddFIDCommand},
    {WM_INITDIALOG,     MsgaddFIDInit},
//	{WM_CLOSE,			MsgaddFIDClose}
};

MSDI msdiaddFID =
{
    sizeof(rgmsdaddFID) / sizeof(MSD),
    rgmsdaddFID,
    edwpNone
};

// Connect dialog command table definition.
CMD rgcmdaddFID[] =
{
    {IDOK,			CmdaddFIDOk},
	{IDCANCEL,		CmdaddFIDCancel},
	{IDC_ADD_FID,	CmdaddFIDEnableOK},
};

CMDI cmdiaddFID =
{
    sizeof(rgcmdaddFID) / sizeof(CMD),
    rgcmdaddFID,
    edwpNone
};


LRESULT CALLBACK addFID(HWND hdlg, UINT msg, WPARAM wparam, LPARAM lparam)
{
    return DispMessage(&msdiaddFID, hdlg, msg, wparam, lparam);
}

LRESULT MsgaddFIDInit(HWND hdlg, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	SendDlgItemMessage(hdlg,IDC_ADD_FID,EM_LIMITTEXT,8,0);
	SetDlgItemText(hdlg,IDC_ADD_FID,"");
	SetDlgItemText(hdlg,IDC_ADD_FID_EDIT," Է ٸ ֽϴ.");
	khos.dlg_AddFid_Init(hdlg);
	SetFocus(GetDlgItem(hdlg,IDC_ADD_FID));
    return (TRUE);
}

LRESULT MsgaddFIDCommand(HWND   hwnd, UINT   uMessage, WPARAM wparam, LPARAM lparam)
{
    return DispCommand(&cmdiaddFID, hwnd, wparam, lparam);
}


LRESULT CmdaddFIDOk(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
	char fid[11];
	Session_Record sr;
	GetDlgItemText(hdlg,IDC_ADD_FID,fid,10);
	SetDlgItemText(hdlg,IDC_ADD_FID_EDIT,"  ٸ ֽϴ.");
	khos.net_SendData(ADDF,sr,fid);
	SetFocus(GetDlgItem(hdlg,IDC_ADD_FID));
    return TRUE;
}

LRESULT CmdaddFIDCancel(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
	EndDialog(hdlg,FALSE);
    return TRUE;
}

LRESULT CmdaddFIDEnableOK(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
	char fid[11];
	GetDlgItemText(hdlg,IDC_ADD_FID,fid,10);
	if(wNotify == EN_CHANGE)
	{
		if(strcmp(fid,""))
			EnableWindow(GetDlgItem(hdlg,IDOK),TRUE);
		else
			EnableWindow(GetDlgItem(hdlg,IDOK),FALSE);
	}
    return TRUE;
}
