
#include "../osp_mClass.h"
#include <windows.h>            // required for all Windows applications
#include <windowsx.h>

#include "../osp_global.h"            
#include "../osp_win/osp_dispatch.h"


//	variables
extern SOCKET           sock;         // socket handle
extern SOCKADDR_IN		 addr;         // Address structure
//extern char * ip;
extern char * port;
//   Function Definitions

//	Main Callback Fuction
LRESULT CALLBACK Bolt(HWND, UINT, WPARAM, LPARAM);

//	Event Function
LRESULT MsgBoltInit(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgBoltCommand(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgBoltClose(HWND, UINT, WPARAM, LPARAM);

//	Command Function
LRESULT CmdBoltOk(HWND, WORD, WORD, HWND);
LRESULT CmdBoltCancel(HWND, WORD, WORD, HWND);
LRESULT CmdBoltEnableOK(HWND, WORD, WORD, HWND);

// Connect dialog message table definition.
MSD rgmsdBolt[] =
{
    {WM_COMMAND,        MsgBoltCommand},
    {WM_INITDIALOG,     MsgBoltInit},
	{WM_CLOSE,			MsgBoltClose}
};

MSDI msdiBolt =
{
    sizeof(rgmsdBolt) / sizeof(MSD),
    rgmsdBolt,
    edwpNone
};

// Connect dialog command table definition.
CMD rgcmdBolt[] =
{
    {IDOK,			CmdBoltOk},
	{IDCANCEL,		CmdBoltCancel},
	{IDC_BOLT_PASS, CmdBoltEnableOK}
};

CMDI cmdiBolt =
{
    sizeof(rgcmdBolt) / sizeof(CMD),
    rgcmdBolt,
    edwpNone
};


LRESULT CALLBACK Bolt(HWND hdlg, UINT msg, WPARAM wparam, LPARAM lparam)
{
    return DispMessage(&msdiBolt, hdlg, msg, wparam, lparam);
}

LRESULT MsgBoltInit(HWND hdlg, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	SendDlgItemMessage(hdlg,IDC_BOLT_PASS,EM_LIMITTEXT,6,0);
	SetDlgItemText(hdlg,IDC_BOLT_EDIT," Է ٸ ֽϴ.");
	
    return (TRUE);
}

LRESULT MsgBoltCommand(HWND   hwnd, UINT   uMessage, WPARAM wparam, LPARAM lparam)
{
    return DispCommand(&cmdiBolt, hwnd, wparam, lparam);
}

LRESULT MsgBoltClose(HWND   hwnd, UINT   uMessage, WPARAM wparam, LPARAM lparam)
{
    return 0;
}

LRESULT CmdBoltOk(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
	char SetInfo[50];

	sock = socket(PF_INET, SOCK_STREAM,0);
							 
    if(sock==INVALID_SOCKET){
	khos.Error("socket() error");
    }
	else
	{
		ZeroMemory(&addr, 0);
		addr.sin_family=AF_INET;
		addr.sin_addr.s_addr=inet_addr(khos.joinIP);
		addr.sin_port=htons(atoi(port));

	//õ
    if (connect(sock,(SOCKADDR*)&addr,
                sizeof(addr)) == SOCKET_ERROR)
    {
	  khos.Error("Bolt server connect() error");
    }
	else
	{
		//debug
		khos.dlg_Debug_Log_Show("Try Connecting...");
		wsprintf(SetInfo,"Server IP : %s",khos.joinIP);
		khos.dlg_Debug_Log_Show(SetInfo);
		wsprintf(SetInfo,"Server port : %s",port);
		khos.dlg_Debug_Log_Show(SetInfo);
		//debug

		int strlen=0;
		char * id = new char[9];
		char pass[10];
		Packet BoltPac;
		Packet * pBolt;
		char recvbuf[100];
	
		BoltPac.InsertQR_Type(OSPP_BOLT);
		khos.Get_User_Name(id);
		GetDlgItemText(hdlg,IDC_BOLT_PASS,pass,9);
		BoltPac.AppendField(id);
		BoltPac.AppendField(pass);
	
		strlen= send(sock,BoltPac.GetPacketStream(),BoltPac.GetPacketSize(),0);
		if(!strlen)
		{
			SetDlgItemText(hdlg,IDC_BOLT_EDIT,"޼   ߽ϴ.");
			khos.Error("Bolt fail...");
		}
		else
		{
			SetDlgItemText(hdlg,IDC_BOLT_EDIT," ޼ ½ϴ.");
			strlen = recv(sock,recvbuf,100,0);
			SetDlgItemText(hdlg,IDC_BOLT_EDIT,"  ٸ ֽϴ.");
			if(!strlen)
			{
				SetDlgItemText(hdlg,IDC_BOLT_EDIT,"Ż .");
				khos.Error("Bolt fail...");
			}//end if(!strlen)
			else
			{
				pBolt = (Packet *)recvbuf;
				if(pBolt->GetQR_Type()==OSPP_GBYE)
				{
					SetDlgItemText(hdlg,IDC_BOLT_EDIT,"ŻǾϴ.");
					closesocket(sock);
					SetDlgItemText(hdlg,IDC_BOLT_PASS,"");
					SetFocus(GetDlgItem(hdlg,IDCANCEL));
					SendMessage(khos.Get_hWnd(),WM_COMMAND,40002,0);
					Sleep(1000);
					EndDialog(hdlg,TRUE);
					return true;
				}
				else
				{
					SetDlgItemText(hdlg,IDC_BOLT_EDIT,"Ż  ߽ϴ.");
					closesocket(sock);
					SetDlgItemText(hdlg,IDC_BOLT_PASS,"");
					SetFocus(GetDlgItem(hdlg,IDCANCEL));
					return false;
				}
			}//end else
			closesocket(sock);
		}//end else
	}//end connect
	}//end socket
	return true;
}

LRESULT CmdBoltCancel(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
	closesocket(sock);
    EndDialog(hdlg, FALSE);
    return TRUE;
}

LRESULT CmdBoltEnableOK(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
	char pass[11];
	GetDlgItemText(hdlg,IDC_BOLT_PASS,pass,10);
	if(wNotify == EN_CHANGE)
	{
		if(strcmp(pass,""))
			EnableWindow(GetDlgItem(hdlg,IDOK),TRUE);
		else
			EnableWindow(GetDlgItem(hdlg,IDOK),FALSE);
	}
    return TRUE;
}

