
#include "../osp_mClass.h"
#include <windows.h>            // required for all Windows applications
#include <windowsx.h>

#include "../osp_global.h"            
#include "../osp_win/osp_dispatch.h"

//   Function Definitions

//	Main Callback Fuction
LRESULT CALLBACK delFID(HWND, UINT, WPARAM, LPARAM);

//	Event Function
LRESULT MsgdelFIDInit(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgdelFIDCommand(HWND, UINT, WPARAM, LPARAM);
//LRESULT MsgdelFIDClose(HWND, UINT, WPARAM, LPARAM);

//	Command Function
LRESULT CmddelFIDOk(HWND, WORD, WORD, HWND);
LRESULT CmddelFIDCancel(HWND, WORD, WORD, HWND);
LRESULT CmddelFIDEnableOK(HWND, WORD, WORD, HWND);

// Connect dialog message table definition.
MSD rgmsddelFID[] =
{
    {WM_COMMAND,        MsgdelFIDCommand},
    {WM_INITDIALOG,     MsgdelFIDInit},
};

MSDI msdidelFID =
{
    sizeof(rgmsddelFID) / sizeof(MSD),
    rgmsddelFID,
    edwpNone
};

// Connect dialog command table definition.
CMD rgcmddelFID[] =
{
    {IDOK,			CmddelFIDOk},
	{IDCANCEL,		CmddelFIDCancel},
};

CMDI cmdidelFID =
{
    sizeof(rgcmddelFID) / sizeof(CMD),
    rgcmddelFID,
    edwpNone
};


LRESULT CALLBACK delFID(HWND hdlg, UINT msg, WPARAM wparam, LPARAM lparam)
{
    return DispMessage(&msdidelFID, hdlg, msg, wparam, lparam);
}

LRESULT MsgdelFIDInit(HWND hdlg, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	HWND htree=khos.mainTree->GetTreeHandle();
	TVITEM tvi;
	char str[128];

	tvi.mask=TVIF_TEXT;
	tvi.pszText=str;
	tvi.cchTextMax=sizeof(str);

	tvi.hItem=TreeView_GetSelection(htree);
	if(tvi.hItem)
	{
		TreeView_GetItem(htree,&tvi);
		strcpy(khos.DeletedFriend,str);
		strcat(str,"  Ͻðڽϱ?");
		SetDlgItemText(hdlg,IDC_DEL_FID,str);
	}
	khos.dlg_DelFid_Init(hdlg);
    return (TRUE);
}

LRESULT MsgdelFIDCommand(HWND   hwnd, UINT   uMessage, WPARAM wparam, LPARAM lparam)
{
    return DispCommand(&cmdidelFID, hwnd, wparam, lparam);
}


LRESULT CmddelFIDOk(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
	Session_Record sr;
	SetDlgItemText(hdlg,IDC_DEL_FID,"  ٸ ֽϴ.");
	khos.net_SendData(DELF,sr,khos.DeletedFriend);

	EnableWindow(GetDlgItem(hdlg,IDOK),FALSE);

    return TRUE;
}

LRESULT CmddelFIDCancel(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
	EndDialog(hdlg,FALSE);
    return TRUE;
}

