
#include <winsock2.h>
#include "./module/osp_net/osp_socket.h"
#include "./module/osp_net/osp_session.h"
#include "./module/osp_net/Packet_Class.h"
#include "ospTreeView.h"

#include <windows.h>
#include "resource.h"

#define AUTH	1000	// ޼
#define CHTC	1001	//ä û ޼
#define CHTS	1002	// ä ޼
#define ECHO	1003	//  ޼	
#define ALOW	1004	//ä 㰡 ޼
#define ALWS	1005	// ä 㰡 ޼
#define FLIF	1006	//ģ  ޼
#define FLRQ	1007	//ģ  û ޼
#define JOIN	1008	//

#define ADDF	1009	//ģ ߰
#define DELF	1010	//ģ 

#define USER	2000	//  ޼

#define LOG_OFF	0		//state  
#define TRY_CON 1
#define LOG_ON  2


struct DebugDlgData
{
	HWND hDebugDlg;
	HWND hLogList;
	HWND hRecvList;
	HWND hSendList;
	HWND hHeaderEdit;
	HWND hDataEdit1;
	HWND hDataEdit2;
	HWND hDataEdit3;
	int  State;

	DebugDlgData()
	{
		State=false;
	}

	DebugDlgData& operator=(DebugDlgData& dlg)
	{
		hDebugDlg=dlg.hDebugDlg;
		hLogList=dlg.hLogList;
		hRecvList=dlg.hRecvList;
		hSendList=dlg.hSendList;
		hHeaderEdit=dlg.hHeaderEdit;
		hDataEdit1=dlg.hDataEdit1;
		hDataEdit2=dlg.hDataEdit2;
		hDataEdit3=dlg.hDataEdit3;
		State = dlg.State;

		return *this;
	}
};

class khosMain
{

public:
	HINSTANCE	g_hinst;
	DebugDlgData DebugDlg;
	ospTreeView * mainTree;
	ospTreeView * optionTree;
	int			mainTreeState;
	SessionClass Session;
    int SessionNum;
	char		DeletedFriend[10];
	char		joinIP[24];

private:
	int			state;
	HWND		hWnd;
	HWND		hLogInDlg;
	HWND		hAddFidDlg;
	HWND		hDelFidDlg;
	int			LogDlgState;
	int			ChatDlgIndex;

	SOCKDATA	ospSock;
	Packet		ospbuf;
	Packet		* Pack;
	
	HANDLE hRecvThread;
	DWORD dwRecvThreadID;
	

	void net_PacketBuild(int type,Session_Record sr,char * data);
	void net_PacketBuild(int type);
	void net_RecvData();// ޱ
	void net_Send();

	void main_Tree_Insert_Group(char *);
	void main_Tree_Insert_Friend(char *);
	void main_Tree_Refresh();

	void dlg_chat_DataSend_ToFriend(char *);
	void dlg_chat_RecvData_ToChatDlg(char *);

public:
	khosMain();
	~khosMain();
	void Error(char * er);
	void khos_Initialize(HINSTANCE,HWND); //α׷ ۽ ʱȭ
	void khos_Online_init();//¶ Ǿ ó
	void khos_LogOut_init();// Ǿ ó

	void net_TryConnect();//α׿ õ
	void net_TryDisconnect();//α ƿ

	friend DWORD WINAPI RecvThread(void * arg);//

	void net_Send(char *);
	void net_SendData(int type,Session_Record sr,char * data);//
	void net_SendData(int type);//
	void net_SendData();// 

	//not used
	void data_SetLonInData(char * user, char * pass);

	void proc_Analyze(int,char *);//Ŷ м
	void proc_Decoding();//ȣȭ
	void proc_Processing();//Ŷ  ó

	void dlg_LogDlg_Init(HWND hdlg);
	void dlg_LogDlg_End();

	void dlg_AddFid_Init(HWND hdlg);
	void dlg_DelFid_Init(HWND hdlg);

	void dlg_Debug_Init(HWND);
	void dlg_Debug_End();
	void dlg_Debug_Log_Show(char *);
	void dlg_Debug_SendData_Show(char *);
	void dlg_Debug_RecvData_Show(char *);

	void dlg_Option_SetServer(char *);
	void dlg_Option_SetJoinServer(char *);

	void dlg_Chat_Command(int);
	void dlg_Chat_Command_dblk(char * FID);
	void dlg_Chat_Command_chts(int num);

	int  dlg_Chat_myDlgNum(char *);

	int  IsDebugWindow();
	int		Get_khos_state(){ return state;}
	void	Get_User_Name(char * name);
	HWND	Get_hWnd(){return hWnd;}

};

extern khosMain khos;