
//	osp-project
//
//  MODULE:   osp_win_cmd.cpp
//

#ifndef OSP_WIN_CMD
#define OSP_WIN_CMD

//#include "../osp_mClass.h"

#include "osp_win_cmd.h"
#include "../osp_net_global.h"

#include <windows.h>            // required for all Windows applications
#include <windowsx.h>

#include "../osp_global.h"


#include "../module/osp_tray/osp_tray.h"


LRESULT CmdConnect(HWND hwnd, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
    if(DialogBox(g_hinst, MAKEINTRESOURCE(IDD_LOGIN_DLG), hwnd, (DLGPROC)Connect)==IDOK)
    {
		//dataReady message ...see osp_win_proc.h
		SendMessage(hwnd,501,0,0);
        return 0;
    }

    return 0;
}

LRESULT CmdDisconnect(HWND hwnd, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
    HMENU hmenu;

	khos.net_TryDisconnect();

    // Fix menus
    hmenu = GetMenu(hwnd);
    EnableMenuItem(hmenu, IDM_CONNECT, MF_ENABLED);
    EnableMenuItem(hmenu, IDM_DISCONNECT, MF_GRAYED);
	EnableMenuItem(hmenu, IDM_JOIN,MF_ENABLED);
	EnableMenuItem(hmenu, IDM_BOLT,MF_GRAYED);
	EnableMenuItem(hmenu, IDM_ADD_FID,MF_GRAYED);
	EnableMenuItem(hmenu, IDM_DEL_FID,MF_GRAYED);

	//Disconnect message ...see osp_win_proc.h
	SendMessage(hwnd,503,0,0);

    SetWindowText(hwnd, szTitle);
	
    return 0;
}


LRESULT CmdExit(HWND hwnd, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
    DestroyWindow(hwnd);

    return 0;
}

LRESULT CmdTray1(HWND hwnd, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
			if(!Tray.TrayMenuProcess(wNotify))
			{
				return 1;
			}

	return 0;
}
LRESULT CmdTray2(HWND hwnd, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
			if(!Tray.TrayMenuProcess(wNotify))
			{
				return 1;
			}
	return 0;
}
LRESULT CmdTray3(HWND hwnd, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
			if(!Tray.TrayMenuProcess(wNotify))
			{
				return 1;
			}
	return 0;
}
LRESULT CmdTrayExit(HWND hwnd, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
			if(!Tray.TrayMenuProcess(wNotify))
			{
				return 1;
			}
	return 0;
}

LRESULT CmdOption(HWND hwnd, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
    // Start dialog box
    if(DialogBox(g_hinst, MAKEINTRESOURCE(IDD_TOOL_OPTIONS), hwnd, (DLGPROC)Option))
    {
        return 0;
    }
    return 0;
}

LRESULT CmdAbout(HWND hwnd, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
    // Start dialog box
    if(DialogBox(g_hinst, MAKEINTRESOURCE(IDD_HELP_ABOUT), hwnd, (DLGPROC)Help))
    {
        return 0;
    }
    return 0;
}

LRESULT CmdJoin(HWND hwnd, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
    // Start dialog box
    if(DialogBox(g_hinst, MAKEINTRESOURCE(IDD_JOIN_DLG), hwnd, (DLGPROC)Join))
    {
        return 0;
    }
    return 0;
}

LRESULT CmdBolt(HWND hwnd, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
    // Start dialog box
    if(DialogBox(g_hinst, MAKEINTRESOURCE(IDD_BOLT_DLG), hwnd, (DLGPROC)Bolt))
    {
        return 0;
    }
    return 0;
}

LRESULT CmdAddFid(HWND hwnd, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
    // Start dialog box
    if(DialogBox(g_hinst, MAKEINTRESOURCE(IDD_ADD_FID), hwnd, (DLGPROC)addFID))
    {
        return 0;
    }
    return 0;
}

LRESULT CmdDelFid(HWND hwnd, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
    if(DialogBox(g_hinst, MAKEINTRESOURCE(IDD_DEL_FID), hwnd, (DLGPROC)delFID))
    {
        return 0;
    }
    return 0;
}

LRESULT CmdDebug(HWND hwnd, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
    // Start dialog box
    if(!IsWindow(khos.DebugDlg.hDebugDlg))
	{
		khos.DebugDlg.hDebugDlg=CreateDialog(g_hinst, MAKEINTRESOURCE(IDD_TOOL_DEBUG), hwnd, (DLGPROC)Debug);
    
		ShowWindow(khos.DebugDlg.hDebugDlg,SW_SHOW);
        return 0;
    }
    return 0;
}
#endif