
#include "../osp_mClass.h"
#include "osp_Dispatch.h"

#include "../module/osp_tray/osp_tray.h"
extern Trayicon Tray;


LRESULT MsgChat(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgCreate(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgSize(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgTimer(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgPaint(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgSetfocus(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgCommand(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgDataready(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgStandby(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgRefreshdisplay(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgDisconnected(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgDestroy(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgTrayProcess(HWND, UINT, WPARAM, LPARAM);

// User Defined Messages

#define MW_STANDBY			600		//α  ADP 
#define MW_CHAT				601
#define MW_DATAREADY       501
#define MW_DISPLAYREFRESH  502
#define MW_DISCONNECTED    503
#define LDM_CONNECTED      504

// Main window message table definition.
MSD rgmsd[] =
{
	{MW_CHAT,			MsgChat},
    {WM_CREATE,         MsgCreate},
    {WM_SIZE,           MsgSize},
	{WM_PAINT,			MsgPaint},
    {WM_SETFOCUS,       MsgSetfocus},
    {WM_COMMAND,        MsgCommand},
	{WM_TIMER,			MsgTimer},
    {WM_DESTROY,        MsgDestroy},
	{MW_STANDBY,		MsgStandby},
    {MW_DATAREADY,      MsgDataready},
    {MW_DISCONNECTED,   MsgDisconnected},
    {MW_DISPLAYREFRESH, MsgRefreshdisplay},
	{TRAY_NOTIFY,		MsgTrayProcess}
};

MSDI msdiMain =
{
    sizeof(rgmsd) / sizeof(MSD),
    rgmsd,
    edwpWindow
};


extern CMD rgcmd;
extern CMDI cmdiMain;