
#ifndef JAGUARX_H
#define JAGUARX_H

#pragma warning(disable:4786)
#pragma warning(disable:4503)

#include <iostream>
#include <cstring>
#include <string>

#include "./judo/judo.hpp"
#include "jutil.h"
//#include "sig.h"

using namespace judo;
using namespace std;


//#define ElementCallbackfunc		void(*func)(const Element& e)

const int ERR_UNAUTHORIZED = 401;

namespace JaguarX
{

class JSession;
class JID;
class JPacket;
class JPresence;
class JPresenceDB;
class JRoster;

class JSig
{
public:
	JSig(){};
	~JSig(){};
	virtual void OnAuthTypeReceived(const Element &t){};
	virtual void IQHandler_Auth(const Element &t){};
	virtual void IQHandler_CreateUser(const Element &t){};
	virtual void deleteAgent(const Element& iq){};
	virtual void on_fetch(const Element& iq){};
};

class SigFuncElement 
{
	void (*func)(JSig * inst,const Element& t);
public:
	SigFuncElement(){};
	~SigFuncElement(){};
	void exec(JSig * inst,const Element& t);
	void join(void(*f)(JSig * inst,const Element&t));

};

}

using namespace JaguarX;

char* shahash(const char* str);

#include "Roster.h"

#include "XCP.H"
#include "JaguarEx.h"
#include "JID.h"
#include "Message.h"
#include "Packet.h"
#include "Presence.h"
#include "PresenceDB.h"
#include "Session.h"

/////////////////
#endif