

#pragma warning(disable:4786)

#include "JaguarX.h"


//̸ element ʱȭ Ѵ.
JPacket::JPacket(const string& name)
     : _base(name)
{}

//Element ʱȭ Ѵ.
JPacket::JPacket(const Element& t)
     : _base(t)
{}

//from
// <some	from = " " >
const string JPacket::getFrom() const
{
     return _base.getAttrib("from");
}

// <some	to = " " >
const string JPacket::getTo() const
{
     return _base.getAttrib("to");
}

// <some	id = " " >
const string JPacket::getID() const
{
     return _base.getAttrib("id");
}

const string JPacket::getError() const
{
     return string(_base.getChildCData("error"));
}

// ڵ ȣ Ѵ.
const int JPacket::getErrorCode() const
{
     const Element* error = _base.findElement("error");
     if (error)
	  return atoi(error->getAttrib("code").c_str());
     else
	  return 0;
}


// XML Ʈ Ѵ. (ڹ Ÿ?)
const string JPacket::toString() const
{
     return _base.toString();
}

// Ʈ 
const Element& JPacket::getBaseElement() const
{
     return _base;
}

// Ӽ 
void JPacket::setFrom(const string& from)
{
     _base.putAttrib("from", from);
}

void JPacket::setTo(const string& to)
{
     _base.putAttrib("to", to);
}

void JPacket::setID(const string& id)
{
     _base.putAttrib("id", id);
}

// x  ǹ̰ ?
// khos_no
Element* JPacket::addX()
{
     return _base.addElement("x");
}

// x Ʈ ߰ϰ x Ӽ xmlns Ӽ ߰Ѵ.
Element* JPacket::addX(const string& tnamespace)
{
     Element* x = _base.addElement("x");
     x->putAttrib("xmlns", tnamespace);
     return x;
}

// x  xmlns  ġϴ Ʈ ãƼ Ѵ.
Element* JPacket::findX(const string& tnamespace) const
{
     Element::const_iterator it = _base.begin();
     for (; it != _base.end(); it++)
     {
	  if (((*it)->getType() == Node::ntElement) && 
	      ((static_cast<Element*>(*it))->cmpAttrib("xmlns", tnamespace)))
	       break;
     }
     if (it != _base.end())
	  return static_cast<Element*>(*it);
     else
	  return NULL;
}

// x  xmlns  ġϴ Ʈ Ѵ.
void JPacket::eraseX(const string& tnamespace)
{
     Element::iterator it = _base.begin();
     for (; it != _base.end(); it++)
     {
	  if (((*it)->getType() == Node::ntElement) && 
	      ((static_cast<Element*>(*it))->cmpAttrib("xmlns", tnamespace)))
	       break;
     }
     if (it != _base.end())
	  static_cast<Element*>(*it)->erase(it);
}

Element& JPacket::getBaseElement()
{
     return _base;
}


