
#ifndef PACKET_H
#define PACKET_H

#include "JaguarX.h"

namespace JaguarX
{


class JPacket
{
public:
	
	JPacket(const string& name);
	JPacket(const Element& t);
	
	const string getFrom()    const;
	const string getTo()      const;
	const string getID() const;
	const string getError() const;
	const int getErrorCode() const;
	const string toString()      const;
	const Element&   getBaseElement() const;
	void setFrom(const string& from);
	void setTo(const string& to);
	void setID(const string& id);
	
	Element* addX();
	Element* addX(const string& tnamespace);
	Element* findX(const string& tnamespace) const;
	void eraseX(const string& tnamespace);
	Element& getBaseElement();
	
protected:
	Element _base;
		  
};

}//end of JaguarX namespace


#endif