
#ifndef ROSTER_H
#define ROSTER_H


//#include "common.h"
#include "JaguarX.h"
//#include "Session.h"
//#include "XCP.H"

/*
namespace JaguarX
{


class JRoster
{
public:
	
	enum Subscription {
		rsNone,  //< Neither of you can see the other's JPresence. 
			rsTo,    //< You can see their JPresence, but they cannot see yours. 
			rsFrom,  //< You cannot see their JPresence, but they can see yours. 
			rsBoth,  //< Both of you can see each other's JPresence. 
			rsRemove //< This JRoster Item is being removed. 
	};

class Item {
public:
	Item(const Element& t);
	Item(JRoster& r, const Element& t);
	Item(const string& jid, const string& nickname);
	~Item();
public:
	void addToGroup(const string& group);
	void delFromGroup(const string& group);
	void clearGroups();
	void setNickname(const string& nickname);
	void setJID(const string& jid);
	bool             isAvailable() const;
	string           getNickname() const;
	string           getJID() const;
	Subscription     getSubsType() const;
	bool             isPending() const;
	
	// Group pseudo-container ops/iterators
	typedef set<string>::const_iterator iterator;
	iterator begin() const { return _groups.begin(); }
	iterator end()   const { return _groups.end(); }
	bool     empty() const { return _groups.empty(); }
	
protected:
	// Update handlers
	void update(JRoster& r, const string& jid, const JPresence& p, JPresence::Type prev_type);
	bool update(const Element& t);
	bool update(JRoster& r, const Element& t);
private:
	friend class JRoster;
	int          _rescnt;
	set<string>  _groups;
	Subscription _type;
	bool         _pending;
	string       _nickname;
	string       _jid;
};
//////////////////////////////////////////////////////////////
		  
///////////////////////////////////////////		  
	class XCP_InvalidJID : public XCP{};
	
	
	typedef map<string, Item, jutil::CaseInsensitiveCmp> ItemMap;
	
	// Non-const iterators
	typedef jutil::ValueIterator<ItemMap::iterator, Item > iterator;
	iterator begin() { return _items.begin(); }
	iterator end() { return _items.end(); }
	
	// Const iterators
	typedef jutil::ValueIterator<ItemMap::const_iterator, const Item> const_iterator;
	const_iterator begin() const { return _items.begin(); }
	const_iterator end() const { return _items.end(); }

	JRoster(JSession& s);
	JSession& getSession() { return _owner; }
	const JRoster::Item& operator[](const string& jid) const;
	JRoster& operator<<(const Item& i) { update(i); return *this; }

public:
	void reset();
	
	bool containsJID(const string& jid) const;
	
	void update(const Element& t);
	void update(const JPresence& p, JPresence::Type prev_type); 
	void update(const Item& i);	   // JRoster item add/modify
	
	void deleteUser(const string& jid); // Remove the user w/ JID 
	void fetch() const;                 // Retrieve JRoster from server              
	
	// Translation
	static string translateS10N(Subscription stype);
	static Subscription translateS10N(const string& stype);
	static string filterJID(const string& jid);
	
	// Item/Group access -- HACK
	const map<string, set<string> >& getGroups() const { return _groups;} 
public:
	//Signal0<void, Marshal<void> >    evtRefresh;
	//Signal3<void, const string&, bool, JPresence::Type, Marshal<void> > evtPresence;

	void(*evtRefresh)(void);
	void(*evtPresence)(const string&,bool,JPresence::Type);

private:
	friend class Item;
	void mergeItemGroups(const string& itemjid, const set<string>& oldgrp, const set<string>& newgrp);
	void removeItemFromGroup(const string& group, const string& jid);
	void removeItemFromAllGroups(const Item& item);
	void deleteAgent(const Element& iq);
	ItemMap                   _items;
	map<string, set<string> > _groups;
	JSession&                  _owner;
};


}//end of JaguarX namespace

*/

#endif