
#pragma warning(disable:4786)

#include <WINSOCK2.H>
#include <WINDOWS.H>
#include <PROCESS.H>
//#include <tchar.h>

#include "JaguarX.h"

#define BUFSIZE 1024
#define NAMESIZE 20

DWORD WINAPI SendMSG(void *arg);
DWORD WINAPI RecvMSG(void *arg);
void ErrorHandling(char *message);
int	 ParseCmd(char * cmd);
void SetRoster(int num);


SOCKET sock;
JSession session;
char gserver[NAMESIZE];
char gname[NAMESIZE];
char gpasswd[NAMESIZE];

int curRosterNum;
char curRoster[NAMESIZE];


void evtXMLParserError(int a,const string& str)
{
	cout<<"|============== evtXMLParserError ==============|"<<endl;
	cout<<"Code : "<<a <<" "<<str<<endl;
}

void evtTransmitPacket(const JPacket&)
{
	cout<<"|============== evtTransmitPacket ==============|"<<endl;
}
void evtConnected(const Element&)
{
	cout<<"|============== evtConnected ==============|"<<endl;
}
void evtDisconnected(void)
{
	cout<<"|============== evtDisconnected ==============|"<<endl;
}

//message ±װ   óѴ.
void evtMessage(const JMessage& msg)
{
	cout<<"|============== evtMessage ==============|"<<endl;
	cout<<"["<<msg.getFrom().c_str()<<"] : "<<msg.getBody().c_str()<<endl;
//	cout<<_T(msg.getBody().c_str())<<endl;
//	string from = msg.getFrom();
//	string body = msg.getBody();

//	char body[BUFSIZE];
//	WideCharToMultiByte(CP_ACP,0,msg.getBody().c_str(),-1,body,1024,NULL,NULL);
//	cout<<body<<endl;	

//	wstring rfrom;
//	rfrom._Copy()
//	wstring rbody;
//	wstring rfrom(from.begin(), from.end());
//	wstring rbody(body.begin(), body.end());
//	cout<<"["<<rfrom<<"] : "<<rbody<<endl;
//	cout<<"["<<from<<"] : "<<body<<endl;
}
void evtIQ(const Element& t)
{
	cout<<"|============== evtIQ ==============|"<<endl;

    const Element* q = t.findElement("query");

    // Catch the odd case of an IQ not having a <query> tag..
    // It's not really so odd, temas, there is browsing ;)
    if (q == NULL) return;

    // jabber:iq:oob
    if (t.cmpAttrib("type", "set") && q->cmpAttrib("xmlns", "jabber:iq:oob"))
    {
//        manage(new FTRecvView(t));
    }
}
void evtMyPresence(const JPresence&)
{
	cout<<"|============== evtMyPresence ==============|"<<endl;
}
void evtPresence(const JPresence&,JPresence::Type)
{
	cout<<"|============== evtPresence ==============|"<<endl;
}
void evtPresenceRequest(const JPresence&)
{
	cout<<"|============== evtPresenceRequest ==============|"<<endl;
}
void evtUnknownPacket(const Element&)
{
	cout<<"|============== evtUnknownPacket ==============|"<<endl;
}
void evtAuthError(int,const char*)
{
	cout<<"|============== evtAuthErrorError ==============|"<<endl;
}
void evtOnRoster(void)
{
	cout<<"|============== evtOnRoster ==============|"<<endl;

	// Roster ̺Ʈ ...
	// Roster state displayϰ presence  .
	JPresence p("", JPresence::Type::ptAvailable, JPresence::Show::stOnline,"login","1");
	string str= p.toString();
	session << str.c_str();

}
void evtOnVersion(string&,string&,string&)
{
	cout<<"|============== evtOnVersion ==============|"<<endl;
}
void evtOnLast(string&)
{
	cout<<"|============== evtOnLast ==============|"<<endl;
}
void evtOnTime(string&,string&)
{
	cout<<"|============== evtOnTime ==============|"<<endl;
}
void evtTransmitXML(const char * data)
{
	cout<<"[SEND] : "<<data<<endl;
	send(sock,data,strlen(data),0);
}

// ޼
// XML ͸ ǥ  ִ.
void evtRecvXML(const char * data)
{
	cout<<"[RECV] : "<<data<<endl;
}

void initSession()
{
	session.evtAuthError = &evtAuthError;
	session.evtConnected = &evtConnected;
	session.evtDisconnected = &evtDisconnected;
	session.evtIQ = &evtIQ;
	session.evtMessage = &evtMessage;
	session.evtMyPresence = &evtMyPresence;
	session.evtOnLast = &evtOnLast;
	session.evtOnRoster = &evtOnRoster;
	session.evtOnTime = &evtOnTime;
	session.evtOnVersion = &evtOnVersion;
	session.evtPresence = &evtPresence;
	session.evtPresenceRequest = &evtPresenceRequest;
	session.evtRecvXML = &evtRecvXML;
	session.evtTransmitPacket = &evtTransmitPacket;
	session.evtTransmitXML = &evtTransmitXML;
	session.evtUnknownPacket = &evtUnknownPacket;
	session.evtXMLParserError = &evtXMLParserError;

	cout<<"Enter Server : ";
	cin>>gserver;
	cout<<"Enter Jabber ID : ";
	cin>>gname;
	cout<<"Enter password : ";
	cin>>gpasswd;
}

void main(int argc,char ** argv)
{
	
	
	WSADATA wsaData;
	//	SOCKET sock;
	SOCKADDR_IN servAddr;
	
	HANDLE hThread1, hThread2;
	DWORD dwThreadID1, dwThreadID2;
	
	
	if(argc!=2){
	printf("Usage : %s <IP>\n", argv[0]);
	exit(1);
	}
	
	
	if(WSAStartup(MAKEWORD(2, 2), &wsaData) != 0) /* Load Winsock 2.2 DLL */
		ErrorHandling("WSAStartup() error!");
	
	sock=socket(PF_INET, SOCK_STREAM, 0);
	if(sock == INVALID_SOCKET)
		ErrorHandling("socket() error");
	
	memset(&servAddr, 0, sizeof(servAddr));
	servAddr.sin_family=AF_INET;
	servAddr.sin_addr.s_addr=inet_addr(argv[1]);
	servAddr.sin_port=htons(atoi("5222"));
	
	initSession();
	
	if(connect(sock, (SOCKADDR*)&servAddr, sizeof(servAddr))==SOCKET_ERROR)
		ErrorHandling("connect() error");
	
	hThread1 = CreateThread(NULL, 0, SendMSG, (void*)sock, 0, &dwThreadID1); 
	hThread2 = CreateThread(NULL, 0, RecvMSG, (void*)sock, 0, &dwThreadID2);
	if(hThread1==0 || hThread2==0) {
		ErrorHandling("  ");
	}
	
	WaitForSingleObject(hThread1, INFINITE);
	WaitForSingleObject(hThread2, INFINITE);
	
	closesocket(sock);
	
}


DWORD WINAPI SendMSG(void *arg) // ޽    Լ
{
	SOCKET sock = (SOCKET)arg;
	char message[BUFSIZE];
	
//	session.connect("localhost",JSession::AuthType::atAutoAuth,"root","console","verecom");
	session.connect(gserver,JSession::AuthType::atAutoAuth,gname,"test",gpasswd);
	
	session.authenticate();
	
//	WCHAR wszMsg[BUFSIZE];
	
	while(1) {
		fgets(message, BUFSIZE, stdin);
/*		
		if(!strcmp(message,"q\n")) {  // 'q' Է½ 
			closesocket(sock);
			exit(0);		 
		}

		MultiByteToWideChar( CP_ACP, 0, message, strlen(message)+1, wszMsg,   
			sizeof(wszMsg)/sizeof(wszMsg[0]) );
*/
		if(ParseCmd(message)<0)
		{
			closesocket(sock);
			exit(0);
		}
	}
}

DWORD WINAPI RecvMSG(void *arg) /* ޽    Լ */
{
	SOCKET sock = (SOCKET)arg;
	char nameMessage[NAMESIZE+BUFSIZE];
	int strLen;

	while(1){
		strLen = recv(sock, nameMessage, NAMESIZE+BUFSIZE-1, 0);
		if(strLen==-1) return 1;
		
		nameMessage[strLen]=0;
		session.push(nameMessage,strLen);
	}
}

void ErrorHandling(char *message)
{
	fputs(message, stderr);
	fputc('\n', stderr);
	exit(1);
}

int	 ParseCmd(char * cmd)
{
	// 
	if(cmd[0]=='/')
	{
		// ȭ 
		if(cmd[1]=='s')
		{
			if(cmd[3])
			{
				char ros[2];
				ros[0]=cmd[3];
				ros[1]=0;
				SetRoster(atoi(ros));
			}
			return 1;
		}
		else if(cmd[1]=='q')
		{
			return -1;
		}
	}
	// ƴ 
	else
	{
		WORD wc[1024];
		MultiByteToWideChar( CP_ACP, 0, cmd, strlen(cmd)+1, wc, 1);
		wstring m_wstr(wc);
		
		cout<<""<<m_wstr.c_str()<<endl;
		//JMessage msg(curRoster,);
		//session << msg;
		return 0; //׳ Ѵ.
	}
	return 0;
}

void SetRoster(int num)
{
	switch(num) {
	case 1:
		strcpy(curRoster,"kyle@localhost");
		break;
	case 2:
		break;
	default:
		;
	}
}
