// BasePane.h : header file
//
/////////////////////////////////////////////////////////////////////////////
//
//  PROJECT: Outlook Express Style
//	MODULE: Base Pane
//	VERSION: 0.1
//
//		OPERATOR: Jeong Sung-won
//		CONTACT: stupi@neoidea.com
//
//		LAST UPDATE: 2002-05-21
//
//
//	Copylefts (c) 2002 Jeong Sung-won
//	All rights NOT reserved.
//

#if !defined(AFX_BASEPANE_H__A41F36EC_DB1D_4142_B0C9_CFBF928058D2__INCLUDED_)
#define AFX_BASEPANE_H__A41F36EC_DB1D_4142_B0C9_CFBF928058D2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



#define BPN_CLOSE		(WM_USER + 4444)

/////////////////////////////////////////////////////////////////////////////
// CBasePane window

class CBasePane : public CWnd
{
// Construction
public:
	CBasePane();


// Attributes
public:
	CWnd* m_pChildWnd;
	BOOL m_bShow;

protected:
	CRect m_rcCaption;
	CRect m_rcClose;


// Operations
protected:
	BOOL TrackClose(CPoint point);


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBasePane)
	public:
	virtual BOOL Create(LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd);
	//}}AFX_VIRTUAL


// Implementation
public:
	virtual ~CBasePane();


	// Generated message map functions
protected:
	//{{AFX_MSG(CBasePane)
	afx_msg void OnNcCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS FAR* lpncsp);
	afx_msg void OnNcPaint();
	afx_msg UINT OnNcHitTest(CPoint point);
	afx_msg void OnWindowPosChanged(WINDOWPOS FAR* lpwndpos);
	afx_msg void OnNcMouseMove(UINT nHitTest, CPoint point);
	afx_msg void OnNcLButtonDown(UINT nHitTest, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};



/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BASEPANE_H__A41F36EC_DB1D_4142_B0C9_CFBF928058D2__INCLUDED_)
