
import java.io.*;
import java.net.*;
import java.security.*;

import javax.net.ssl.*;
//import com.sun.net.ssl.*;

public class sslTestServer
{
	private static final int port = 2000;
	Socket s ;
	ServerSocket ss;

	class mychatter implements Runnable
	{
		private Socket s;
		private DataOutputStream dos;
		private DataInputStream dis;

		public mychatter(Socket s) throws Exception
		{
			this.s = s;
			dos = new DataOutputStream(s.getOutputStream());
			dis = new DataInputStream(s.getInputStream());
		}

		public void run()
		{
			try{
				String str = dis.readUTF();

				while(str!=null)
				{
					System.out.println(Thread.currentThread().getName() + " : " + str);
					dos.writeUTF(str);
					str = dis.readUTF();
				}
				dos.close();
				dis.close();
				s.close();
			}catch(Exception ex)
			{
				ex.printStackTrace();
			}
		}

	};

	public sslTestServer()
	{
		// ŰҸ εѴ.
		char [] passphrase = "verecom".toCharArray();
		KeyStore keystore = KeyStore.getInstance("JKS");
		keystore.load(new FileInputStream(".keystore"),passphrase);

		//Ű ҷ KeyManagerFactory ʱȭ Ѵ.
		KeyManagerFactory kmf = KeyManagerFactory.getInstance("SunX509");
		kmf.init(keystore , passphrase);

		//SSLContext ϰ KeyManagerFactory KeyManager ʱȭ Ѵ.
		SSLContext context = SSLContext.getInstance("TLS");
		KeyManager[] keymanagers = kmf.getKeyManagers();

		context.init(keymanagers,null,null);


//		SSLServerSocketFactory ssf = (SSLServerSocketFactory) SSLServerSocketFactory.getDefault();
		SSLServerSocketFactory ssf = context.getServerSocketFactory();
		ss = ssf.createServerSocket(port);
	}

	public void startServer()
	{
		while(true)
		{
			try{
				
				s= ss.accept();
//				new Thread(new chatter(s)).start();

			}catch(Exception e)
			{
				e.printStackTrace();
			}
			new Thread(new mychatter(s)).start();
		}

/*		BufferedReader in = new BufferedReader(new InputStreamReader(s.getInputStream()));

		String line=null;
		while(((line = in.readLine()) != null))
		{
			System.out.println(line);
		}
		in.close();
		s.close();

*/
	}

	public void deb(String s)
	{
		System.out.println(s);
	}
	public void deb(String s,String s2)
	{
		System.out.println(s+"  "+s2);
	}

	public static void main ( String[] args) throws Exception
	{

		sslTestServer serv = new sslTestServer();
		serv.startServer();
		
	}


};