#include "Record_Structure.h"
#include "Queue.h"

#define BUFSIZE 100

#define BM_RSP_RECORDNOTFOUND	-2
#define BM_RSP_BUFFEREMPTY		-1
#define BM_RSP_BUFFERFULL		0
#define BM_RSP_INSERTED			1
#define BM_RSP_RECORDFOUND		2

#define SESSION_BUFFER_SIZE 10

class Session_Buf
{
	Session_Record Ses_Buf[SESSION_BUFFER_SIZE];
	int count;
	int findSessionIndex(const char* ID);
	int findSessionIndex(const SOCKET& c_sok);
public:
	Session_Buf();
	~Session_Buf();
	int insertSession(const Session_Record& SR);
	int findSession(const char* ID, Session_Record& SR);
	int findSession(const SOCKET& c_sok, Session_Record& SR);
	int deleteSession(const char* ID);
	int deleteSession(const SOCKET& c_sok);
	int modifySession(const SOCKET& c_sok, const Session_Record& SR);
	int getCount(){ return count; }
};

static HANDLE hSB_Mutex;