#include "common_header.h"

void main()
{
	OSPP_Header* header;
	OSPP_Contents contents;

	char ch[2];
	char buffer[BUFSIZE];

	ch[1] = (char)0;

	strcpy(buffer, "AUTH");
	*ch = (char)2;
	strcat(buffer, ch);
	*ch = (char)3;
	strcat(buffer, ch);
	*ch = (char)3;
	strcat(buffer, ch);
	strcat(buffer, "HYK");
	strcat(buffer, "615");

	Analyze(buffer, &header, contents);

	printf("Header : \n");
	printf("QR_Type : %d\n",header->QR_Type);
	printf("Field_Num : %d\n",(int)header->Field_Num);

	int data_offset = 0;

	for (int i = 0; i < (int)header->Field_Num; i++)
	{
		printf("Field_Len (%d) : %d\n", i, (int)*(contents.Field_Len+i));
		printf("Field data : ");
		for (int j = 0; j < (int)*(contents.Field_Len+i); j++)
			printf("%c",*(contents.data + data_offset + j));
		printf("\n");
		data_offset = (int)*(contents.Field_Len + i);
	}// end for
	switch(AuthenCheck(contents.data, (int)*contents.Field_Len,
					   contents.data + (int)*(contents.Field_Len+1),
					   (int)*(contents.Field_Len+1)))
	{
	case DB_RSP_WRONGPWD :
		printf("WRONG PASSWORD!!\n");
		break;
	case DB_RSP_IDNOTFOUND :
		printf("ID NOT FOUND!!\n");
		break;
	case DB_RSP_APPROVED :
		printf("APPROVED!!\n");
		break;
	default :
		printf("DEFAULT!!\n");
	}//end switch

}// end main()