#include <winsock2.h>

#define ID_SIZE 3

#define SS_STATUS_AUTHFAILED1 -1
#define SS_STATUS_AUTHFAILED2 -2
#define SS_STATUS_ILLEGALTRY1 -3
#define SS_STATUS_ILLEGALTRY2 -4
#define SS_STATUS_USERUNKNOWN 0
#define SS_STATUS_USERONLINE  1
#define SS_STATUS_CONNECTED   2

struct Session_Record
{
	char ID[ID_SIZE];
	//int ID_len;
	SOCKET Client_Socket;
	int User_Status;
	int Session_Status;

	Session_Record()
	{
		User_Status = SS_STATUS_USERUNKNOWN;
		Session_Status = SS_STATUS_CONNECTED;
	//	ID_len = 0;
	}

	Session_Record(char* id, SOCKET c_sok)
	{
	//	ID_len = len;
	//	ID = new char[ID_len];
		for (int i =0; i < ID_SIZE; i++)
			ID[i] = id[i];
		Client_Socket = c_sok;
	}

	Session_Record(const Session_Record& SR)
	{
	//	ID_len = SR.ID_len;
	//	ID = new char[ID_len];
		for (int i =0; i < ID_SIZE; i++)
			ID[i] = SR.ID[i];
		Client_Socket = SR.Client_Socket;
		User_Status = SR.User_Status;
		Session_Status = SR.Session_Status;
	}

	~Session_Record()
	{
	//	delete ID;
	}

	Session_Record operator = (const Session_Record& SR)
	{
	//	ID_len = SR.ID_len;
	//	ID = new char[ID_len];
		for (int i =0; i < ID_SIZE; i++)
			ID[i] = SR.ID[i];
		Client_Socket = SR.Client_Socket;
		User_Status = SR.User_Status;
		Session_Status = SR.Session_Status;
		return *this;
	}
	//void SetMemory(int size)
	//{
	//	ID = new char[size];
	//}
};

struct Packet_Record
{
	char* buf;
	int buf_len;
	SOCKET Client_Socket;

	Packet_Record()
	{
		buf_len = 0;
	}
	Packet_Record(int len, char* outter_buf, SOCKET c_sok)
	{
		buf_len = len;
		buf = new char[len];
		for (int i =0; i < len; i++)
			buf[i] = outter_buf[i];
		Client_Socket = c_sok;
	}
	Packet_Record(const Packet_Record& PR)
	{
		buf_len = PR.buf_len;
		buf = new char[buf_len];
		for (int i = 0; i < buf_len; i++)
			buf[i] = PR.buf[i];
		Client_Socket = PR.Client_Socket;
	}
	Packet_Record operator = (Packet_Record& PR)
	{
		if (!buf_len)
		{
			buf_len = PR.buf_len;
			buf = new char[buf_len];
		}
		for (int i = 0; i < buf_len; i++)
			buf[i] = PR.buf[i];
		Client_Socket = PR.Client_Socket;
		return *this;
	}
	~Packet_Record()
	{
		delete buf;
	}
	
};
