

#ifndef OSP_SOCKET_H
#define OSP_SOCKET_H

//#include <winsock2.h>

#define SID_SIZE 8
#define SPW_SIZE 8

//    Globchat socket data structure to hold all necessary socket information
//


struct SOCKDATA
{
	char			 ID[SID_SIZE];
	char			 passwd[SPW_SIZE];
    SOCKET           sock;         // socket handle
    int              status;       // Socket's status
    SOCKADDR_IN		 addr;         // Address structure
    char             reserved[10]; // Generic sockaddr struct is not big enough for all
                                   // addresses (namely netbios addresses) so adding some
                                   // space at the end.
    int              addrlen;      // Address length
	char 			 ip[24];
	char 			 port[10];

	SOCKDATA & operator = (SOCKDATA & tsock)
	{
		strcpy(ID,tsock.ID);
		strcpy(passwd,tsock.passwd);
		sock=tsock.sock;
		status=tsock.status;
		addr=tsock.addr;
		strcpy(reserved,tsock.reserved);
		addrlen=tsock.addrlen;
		strcpy(ip,tsock.ip);
		strcpy(port,tsock.port);
		return *this;
	}
	SOCKDATA()
	{
		strcpy(ip,"127.0.0.1");
//		strcpy(ip,"192.168.123.117");
		strcpy(port,"1000");
	}
};

typedef struct _SOCKDATA
{
	SOCKDATA sock;
} *LPSOCKDATA;

//  SOCKDATA structure status options
#define SOCKSTAT_INIT        1
#define SOCKSTAT_LISTENING   2
#define SOCKSTAT_ACCEPTING   3
#define SOCKSTAT_CLOSED      4
#define SOCKSTAT_CONNECTED   5
#define SOCKSTAT_AVAILABLE   6
#define SOCKSTAT_INSESSION   7
#define SOCKSTAT_REQSESSION  8


#endif