
#include "../osp_mClass.h"
#include <windows.h>            

#include "../osp_global.h"            
#include "../osp_win/osp_dispatch.h"


//	Main Callback Fuction
LRESULT CALLBACK Debug(HWND, UINT, WPARAM, LPARAM);

//	Event Function
LRESULT MsgDebugInit(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgDebugCommand(HWND, UINT, WPARAM, LPARAM);

//	Command Function
LRESULT CmdDebugOk(HWND, WORD, WORD, HWND);
LRESULT CmdDebugCancel(HWND, WORD, WORD, HWND);
// Connect dialog message table definition.
MSD rgmsdDebug[] =
{
	{WM_INITDIALOG,     MsgDebugInit},
    {WM_COMMAND,        MsgDebugCommand},
};

MSDI msdiDebug =
{
    sizeof(rgmsdDebug) / sizeof(MSD),
    rgmsdDebug,
    edwpNone
};

// Connect dialog command table definition.
CMD rgcmdDebug[] =
{
    {IDOK,			CmdDebugOk},
	{IDCANCEL,		CmdDebugCancel}
};

CMDI cmdiDebug =
{
    sizeof(rgcmdDebug) / sizeof(CMD),
    rgcmdDebug,
    edwpNone
};


LRESULT CALLBACK Debug(HWND hdlg, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
    return DispMessage(&msdiDebug, hdlg, uMessage, wparam, lparam);
}

LRESULT MsgDebugInit(HWND hdlg, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	khos.dlg_Debug_Init(hdlg);
	
	return (TRUE);
}

LRESULT MsgDebugCommand(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
    return DispCommand(&cmdiDebug, hwnd, wparam, lparam);
}


LRESULT CmdDebugOk(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
//	khos.net_Send("hello. This is Khos Messenger.");
//	EndDialog(hdlg, FALSE);

	char group[100];
	char child[100];
	GetDlgItemText(hdlg,IDC_DEBUG_DATA_EDIT2,group,100);
	GetDlgItemText(hdlg,IDC_DEBUG_DATA_EDIT3,child,100);
	if(group!=NULL && child!=NULL)
		khos.mainTree->DeleteChild(group,child);
	else if(group!=NULL && child=="")
		khos.mainTree->DeleteGroup(group);
	else
		;
    return TRUE;
}

LRESULT CmdDebugCancel(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
	khos.dlg_Debug_End();
    DestroyWindow(hdlg);
    return TRUE;
}
