#include <windows.h>            // required for all Windows applications
#include <windowsx.h>

#include "../osp_global.h"            
#include "../osp_win/osp_dispatch.h"
//   Function Definitions

//	Main Callback Fuction
LRESULT CALLBACK Help(HWND, UINT, WPARAM, LPARAM);

//	Event Function
LRESULT MsgHelpInit(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgHelpCommand(HWND, UINT, WPARAM, LPARAM);

//	Command Function
LRESULT CmdHelpOk(HWND, WORD, WORD, HWND);

// Connect dialog message table definition.
MSD rgmsdHelp[] =
{
    {WM_COMMAND,        MsgHelpCommand},
    {WM_INITDIALOG,     MsgHelpInit},
};

MSDI msdiHelp =
{
    sizeof(rgmsdHelp) / sizeof(MSD),
    rgmsdHelp,
    edwpNone
};

// Connect dialog command table definition.
CMD rgcmdHelp[] =
{
    {IDOK,        CmdHelpOk},
};

CMDI cmdiHelp =
{
    sizeof(rgcmdHelp) / sizeof(CMD),
    rgcmdHelp,
    edwpNone
};

LRESULT CALLBACK Help(HWND hdlg, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
    return DispMessage(&msdiHelp, hdlg, uMessage, wparam, lparam);
}

LRESULT MsgHelpInit(HWND hdlg, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	SetDlgItemText(hdlg, IDC_EDIT_ABOUT, "KHOS Messenger by Kang Hyuk");
    return (TRUE);
}

LRESULT MsgHelpCommand(HWND   hwnd, UINT   uMessage, WPARAM wparam, LPARAM lparam)
{
    return DispCommand(&cmdiHelp, hwnd, wparam, lparam);
}

LRESULT CmdHelpOk(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
    EndDialog(hdlg, FALSE);
    return TRUE;
}
