
#include "../osp_mClass.h"
#include <windows.h>            // required for all Windows applications
#include <windowsx.h>

#include "../osp_global.h"            
#include "../osp_win/osp_dispatch.h"


//	variables
SOCKET           sock;         // socket handle
SOCKADDR_IN		 addr;         // Address structure
//char * ip = "127.0.0.1";
char * port = "999";
//   Function Definitions

//	Main Callback Fuction
LRESULT CALLBACK Join(HWND, UINT, WPARAM, LPARAM);

//	Event Function
LRESULT MsgJoinInit(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgJoinCommand(HWND, UINT, WPARAM, LPARAM);
LRESULT MsgJoinClose(HWND, UINT, WPARAM, LPARAM);

//	Command Function
LRESULT CmdJoinOk(HWND, WORD, WORD, HWND);
LRESULT CmdJoinCancel(HWND, WORD, WORD, HWND);
LRESULT CmdJoinEnableOK(HWND, WORD, WORD, HWND);

// Connect dialog message table definition.
MSD rgmsdJoin[] =
{
    {WM_COMMAND,        MsgJoinCommand},
    {WM_INITDIALOG,     MsgJoinInit},
	{WM_CLOSE,			MsgJoinClose}
};

MSDI msdiJoin =
{
    sizeof(rgmsdJoin) / sizeof(MSD),
    rgmsdJoin,
    edwpNone
};

// Connect dialog command table definition.
CMD rgcmdJoin[] =
{
    {IDOK,			CmdJoinOk},
	{IDCANCEL,		CmdJoinCancel},
	{IDC_JOIN_ID,	CmdJoinEnableOK},
	{IDC_JOIN_PASS, CmdJoinEnableOK}
};

CMDI cmdiJoin =
{
    sizeof(rgcmdJoin) / sizeof(CMD),
    rgcmdJoin,
    edwpNone
};


LRESULT CALLBACK Join(HWND hdlg, UINT msg, WPARAM wparam, LPARAM lparam)
{
    return DispMessage(&msdiJoin, hdlg, msg, wparam, lparam);
}

LRESULT MsgJoinInit(HWND hdlg, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	SendDlgItemMessage(hdlg,IDC_JOIN_ID,EM_LIMITTEXT,8,0);
	SendDlgItemMessage(hdlg,IDC_JOIN_PASS,EM_LIMITTEXT,6,0);
	SetDlgItemText(hdlg,IDC_JOIN_HELP,"ID PASS Էϰ ϱ⸦ ּ");
    return (TRUE);
}

LRESULT MsgJoinCommand(HWND   hwnd, UINT   uMessage, WPARAM wparam, LPARAM lparam)
{
    return DispCommand(&cmdiJoin, hwnd, wparam, lparam);
}

LRESULT MsgJoinClose(HWND   hwnd, UINT   uMessage, WPARAM wparam, LPARAM lparam)
{
    return 0;
}

LRESULT CmdJoinOk(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
	char SetInfo[50];
	EnableWindow(GetDlgItem(hdlg,IDOK),FALSE);

	sock = socket(PF_INET, SOCK_STREAM,0);
							 
    if(sock==INVALID_SOCKET){
	khos.Error("socket() error");
    }

	ZeroMemory(&addr, 0);
	addr.sin_family=AF_INET;
	addr.sin_addr.s_addr=inet_addr(khos.joinIP);
	addr.sin_port=htons(atoi(port));

	//õ
    if (connect(sock,(SOCKADDR*)&addr,
                sizeof(addr)) == SOCKET_ERROR)
    {
	  khos.Error("join server connect() error");
    }

	//debug
	khos.dlg_Debug_Log_Show("Try Connecting...");
	wsprintf(SetInfo,"Server IP : %s",khos.joinIP);
	khos.dlg_Debug_Log_Show(SetInfo);
	wsprintf(SetInfo,"Server port : %s",port);
	khos.dlg_Debug_Log_Show(SetInfo);
    //debug

	int strlen=0;
	char id[10];
	char pass[10];
	Packet joinPac;
	Packet * pjoin;
	char recvbuf[100];

	joinPac.InsertQR_Type(OSPP_JOIN);
	GetDlgItemText(hdlg,IDC_JOIN_ID,id,9);
	GetDlgItemText(hdlg,IDC_JOIN_PASS,pass,9);
	joinPac.AppendField(id);
	joinPac.AppendField(pass);

	strlen= send(sock,joinPac.GetPacketStream(),joinPac.GetPacketSize(),0);
	if(!strlen)
	{
		SetDlgItemText(hdlg,IDC_JOIN_HELP,"޼   ߽ϴ.");
		khos.Error("join fail...");
	}
	else
	{
		SetDlgItemText(hdlg,IDC_JOIN_HELP," ޼ ½ϴ.");
		strlen = recv(sock,recvbuf,100,0);
		SetDlgItemText(hdlg,IDC_JOIN_HELP,"  ٸ ֽϴ.");
		if(!strlen)
		{
			SetDlgItemText(hdlg,IDC_JOIN_HELP," .");
			khos.Error("join fail...");
		}//end if(!strlen)
		else
		{
			pjoin = (Packet *)recvbuf;
			if(pjoin->GetQR_Type()==OSPP_WELC)
			{
				SetDlgItemText(hdlg,IDC_JOIN_HELP,"մϴ.  ԵǾϴ.");
				return true;
			}
			else
			{
				SetDlgItemText(hdlg,IDC_JOIN_HELP,"  ߽ϴ.");
				return false;
			}
		}//end else
	}//end else
	return true;
}

LRESULT CmdJoinCancel(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
	closesocket(sock);
    EndDialog(hdlg, FALSE);
    return TRUE;
}

LRESULT CmdJoinEnableOK(HWND hdlg, WORD wCommand, WORD wNotify, HWND hwndCtrl)
{
	char id[11];
	char pass[11];
	GetDlgItemText(hdlg,IDC_JOIN_ID,id,10);
	GetDlgItemText(hdlg,IDC_JOIN_PASS,pass,10);
	if(wNotify == EN_CHANGE)
	{
		if(strcmp(id,"") && strcmp(pass,""))
			EnableWindow(GetDlgItem(hdlg,IDOK),TRUE);
		else
			EnableWindow(GetDlgItem(hdlg,IDOK),FALSE);
	}
    return TRUE;
}

