
#include "resource.h"
#include "osp_mClass.h"
#include "osp_global.h"

khosMain khos;

khosMain::khosMain()
{
	LogDlgState=false;
	state = LOG_OFF;
	ChatDlgIndex=2;
	mainTreeState=0;
	SessionNum=100;
	strcpy(joinIP,"127.0.0.1");
}

khosMain::~khosMain()
{

}

void khosMain::khos_Initialize(HINSTANCE hi,HWND main)
{
	hWnd=main;
	g_hinst=hi;
}

void khosMain::Error(char * er)
{
	if(!strcmp(er,"Send Error"))
	{
		SendMessage(hWnd,WM_COMMAND,IDM_DISCONNECT,0);
	}
	char  msg[50];
	wsprintf(msg,"Error : %s",er);
	if(!DebugDlg.State)
	MessageBox(this->hWnd,msg,"Error",MB_OK);
	this->dlg_Debug_Log_Show(msg);
//	MessageBox(hWnd,er,"error",MB_OK);
//	exit(1);
}

void khosMain::net_TryConnect()
{
	// ʱȭ

	char SetInfo[40];

	ospSock.sock = socket(PF_INET, SOCK_STREAM,0);
							 
    if(ospSock.sock==INVALID_SOCKET){
	Error("socket() error");
    }

	ZeroMemory(&ospSock.addr, 0);
	ospSock.addr.sin_family=AF_INET;
	ospSock.addr.sin_addr.s_addr=inet_addr(ospSock.ip);
	ospSock.addr.sin_port=htons(atoi(ospSock.port));

	//õ
    if (connect(ospSock.sock,
                (SOCKADDR*)&ospSock.addr,
                sizeof(ospSock.addr)) == SOCKET_ERROR)
    {
	  Error("connect() error");
    }
	else
	{

		dlg_Debug_Log_Show("Try Connecting...");
		wsprintf(SetInfo,"Server IP : %s",ospSock.ip);
		dlg_Debug_Log_Show(SetInfo);
		wsprintf(SetInfo,"Server port : %s",ospSock.port);
		dlg_Debug_Log_Show(SetInfo);
		net_RecvData();
		net_SendData(AUTH);
		state=TRY_CON;
	}
}

void khosMain::net_TryDisconnect()
{
	state=LOG_OFF;
	mainTree->DeleteAll();
	dlg_Debug_Log_Show("Disconnected");
	closesocket(ospSock.sock);
	KillTimer(hWnd,1);
}

///////////////////////////////////////////////////////
//	Log In Dialog Func

void khosMain::dlg_LogDlg_Init(HWND hdlg)
{
	hLogInDlg=hdlg;
	LogDlgState=true;
}

void khosMain::dlg_LogDlg_End()
{
	LogDlgState=false;
}

///////////////////////////////////////////////////////
//	Add Friend Dialog Func

void khosMain::dlg_AddFid_Init(HWND hdlg)
{
	hAddFidDlg=hdlg;
}

///////////////////////////////////////////////////////
//	Add Friend Dialog Func

void khosMain::dlg_DelFid_Init(HWND hdlg)
{
	hDelFidDlg=hdlg;
}

///////////////////////////////////////////////////////
//	Debug Dialog Func

void khosMain::dlg_Debug_Init(HWND hdlg)
{
//	if(DebugDlg.hDebugDlg!=hdlg)
//		Error("Debug ڵ Ʋ");
	
	DebugDlg.hLogList=GetDlgItem(hdlg,IDC_DEBUG_LOG_LIST);
	DebugDlg.hRecvList=GetDlgItem(hdlg,IDC_DEBUG_RECV_LIST);
	DebugDlg.hSendList=GetDlgItem(hdlg,IDC_DEBUG_SEND_LIST);
	DebugDlg.hHeaderEdit=GetDlgItem(hdlg,IDC_DEBUG_HEAD_EDIT);
	DebugDlg.hDataEdit1=GetDlgItem(hdlg,IDC_DEBUG_DATA_EDIT1);
	DebugDlg.hDataEdit2=GetDlgItem(hdlg,IDC_DEBUG_DATA_EDIT2);
	DebugDlg.hDataEdit3=GetDlgItem(hdlg,IDC_DEBUG_DATA_EDIT3);
	DebugDlg.State=true;
	
}

void khosMain::dlg_Debug_End()
{
	DebugDlg.hDebugDlg=NULL;
	DebugDlg.State=false;
}

int khosMain::IsDebugWindow()
{
	return DebugDlg.State;
}

void khosMain::dlg_Debug_Log_Show(char * lData)
{
	if(DebugDlg.State)
	{
	int index;
	index=SendMessage(DebugDlg.hLogList,LB_ADDSTRING,0,(LPARAM)lData);
	SendMessage(DebugDlg.hLogList,LB_SETTOPINDEX,index,0);
	}
}

void khosMain::dlg_Debug_RecvData_Show(char *rData)
{
	int index;
	char error[50];

	if(!rData){
		wsprintf(error,"NULL Data Recieved");
	index=SendMessage(DebugDlg.hRecvList,LB_ADDSTRING,0,(LPARAM)error);
	SendMessage(DebugDlg.hRecvList,LB_SETTOPINDEX,index,0);
	}
	else if(DebugDlg.State)
	{
	index=SendMessage(DebugDlg.hRecvList,LB_ADDSTRING,0,(LPARAM)rData);
	SendMessage(DebugDlg.hRecvList,LB_SETTOPINDEX,index,0);
	}
}
void khosMain::dlg_Debug_SendData_Show(char *sData)
{
	if(DebugDlg.State)
	{
	int index;
	index=SendMessage(DebugDlg.hSendList,LB_ADDSTRING,0,(LPARAM)sData);
	SendMessage(DebugDlg.hSendList,LB_SETTOPINDEX,index,0);
	}
}

void khosMain::data_SetLonInData(char * user,char *pass)
{
	strcpy(ospSock.ID,user);
	strcpy(ospSock.passwd,pass);
}

///////////////////////////////////////////////////////
//	Option Dialog Func

void khosMain::dlg_Option_SetServer(char * ser)
{
	char SetInfo[30];
	strcpy(ospSock.ip,ser);

	wsprintf(SetInfo,"ServerIP : %s",ospSock.ip);
	dlg_Debug_Log_Show(SetInfo);
}

void khosMain::dlg_Option_SetJoinServer(char * ser)
{
	char SetInfo[30];
	strcpy(joinIP,ser);

	wsprintf(SetInfo,"Join ServerIP : %s",joinIP);
	dlg_Debug_Log_Show(SetInfo);
}

///////////////////////////////////////////////////////
//	Chat Dialog Func

void khosMain::dlg_Chat_Command(int num)
{
	HWND hdlg;
	hdlg=CreateDialogParam(g_hinst, 
			MAKEINTRESOURCE(IDD_CHAT), 
			hWnd, (DLGPROC)Chat,num);
//	SetForegroundWindow(hWnd);
}

void khosMain::dlg_Chat_Command_dblk(char * FID)
{
	HWND hdlg;
	Session_Record sr;
	if(Session.findSession(FID,sr)!=2)//ǿ 
	{
		strcpy(sr.FID,FID);
		sr.myDlgID=SessionNum++;
		Session.insertSession(sr);
		hdlg=CreateDialogParam(g_hinst, 
				MAKEINTRESOURCE(IDD_CHAT), 
				hWnd, (DLGPROC)Chat,sr.myDlgID);
		SetForegroundWindow(hWnd);
		SetFocus(hdlg);
	}
	else //ǿ ִ.
	{
		if(!IsWindow(sr.hCDlg))//찡 .
		{
			Session.deleteSession(sr.myDlgID);
			sr.myDlgID=SessionNum++;
			strcpy(sr.FID,FID);
			Session.insertSession(sr);
			hdlg=CreateDialogParam(g_hinst, 
				MAKEINTRESOURCE(IDD_CHAT), 
				hWnd, (DLGPROC)Chat,sr.myDlgID);
//			SetForegroundWindow(hWnd);
		}
		else
			SetFocus(sr.hCDlg);
	}
}

//chts
int khosMain::dlg_Chat_myDlgNum(char * FID)
{
	Session_Record sr;
	if(Session.findSession(FID,sr)!=2)//ǿ 
	{
		strcpy(sr.FID,FID);
		sr.myDlgID=SessionNum++;
		Session.insertSession(sr);
	}
	else //ǿ ִ.
	{
		if(!IsWindow(sr.hCDlg))//찡 .
		{
			Session.deleteSession(sr.myDlgID);
			sr.myDlgID=SessionNum++;
			strcpy(sr.FID,FID);
			Session.insertSession(sr);
		}
	}
	return sr.myDlgID;	
}


//////////////////////////////////////////////////////////
//	Recv func

void khosMain::net_RecvData()
{
	hRecvThread = (HWND)CreateThread(NULL, 0, 
		RecvThread, (void*)this, 0, 
		(unsigned long *)&dwRecvThreadID);
	if(hRecvThread == 0) {
		Error("  ");
	}
}

#define BUF_SIZE 100
DWORD WINAPI RecvThread(void * arg)
{
	khosMain * km=(khosMain *)arg;
	
	km->dlg_Debug_Log_Show("RecvThread Created");

	char RecvData[BUF_SIZE];
	int strlen=0;

	char debug[20];

	while(km->state || strlen!=-1)
	{
		strlen=recv(km->ospSock.sock,
			RecvData,BUF_SIZE-1,0);
		if(strlen!=-1)
		{
		wsprintf(debug,"Recv Str len : %d",strlen);
		km->dlg_Debug_RecvData_Show(debug);
		km->dlg_Debug_RecvData_Show(RecvData);
		km->proc_Analyze(strlen,RecvData);
		}

		//strcpy(RecvData,"");
		for(int i=0;i<BUF_SIZE;i++)
			RecvData[i]=0;
	}
	km->dlg_Debug_Log_Show("RecvThread Destroyed");
	return 0;
}

void khosMain::proc_Analyze(int strlen,char * buf)
{
	if(buf==NULL) {
	
		Error("NULL Data");
	}

	
	Pack = (Packet *)buf;
	
	if(!Pack->IsHeaderValid())
		Error("߸ ŶԴϴ.");
	else if (Pack->GetNum_Field() > FIELD_LEN_MAX)
		Error("Ŷ ʹ Ůϴ.");
	else {
		proc_Decoding();
		proc_Processing();
	}
	Pack=NULL;
}

void khosMain::proc_Decoding()
{

}

void khosMain::proc_Processing()
{
	int NumField=0;
	int i;
	Session_Record sr;

	//CHTS
	Session_Record csr;

	//APRV
	HMENU hmenu;
	
	//ADOK
	char AddData[50];

	switch(Pack->GetQR_Type())
	{
	//α׿  ؾ ϵ..
	//ģ Ʈ û Ѵ.
	case OSPP_APRV: state = LOG_ON;
		net_SendData(FLRQ);
		SetTimer(hWnd,1,3000,NULL);
		hmenu=GetMenu(hWnd);
		EnableMenuItem(hmenu,IDM_ADD_FID,MF_ENABLED);
		EnableMenuItem(hmenu,IDM_DEL_FID,MF_ENABLED);
		EnableMenuItem(hmenu,IDM_JOIN,MF_GRAYED);
		EnableMenuItem(hmenu,IDM_BOLT,MF_ENABLED);
	    EnableMenuItem(hmenu, IDM_CONNECT, MF_GRAYED);
		EnableMenuItem(hmenu, IDM_DISCONNECT, MF_ENABLED);
		break;

	//α׿ н..
	case OSPP_RJCT: state = LOG_OFF;
//		dlg_Debug_Log_Show("LogIn Fail");
		Error("Login Fail");		
		SendMessage(hWnd,WM_COMMAND,IDM_DISCONNECT,0);
		break;
	case OSPP_FAIL: 
	case OSPP_ERR0:
		
	// ..
	case OSPP_SCLS:
	
	//ģ Ʈ   ..
	// Ʈ  ־ش.
	case OSPP_FLIF:
		char state[2];
		char FID[100];
		char GID[100];
//		char debug[150];
		NumField=Pack->GetNum_Field();

		for(i=0;i<NumField;i+=3)
		{
			Pack->GetField(i,state);
			state[1]=0;
			Pack->GetField(i+1,FID);
			Pack->GetField(i+2,GID);
			dlg_Debug_RecvData_Show(state);
			dlg_Debug_RecvData_Show(FID);
			dlg_Debug_RecvData_Show(GID);

			HTREEITEM ti;
			ti=mainTree->FindChildAll(GID,FID);
			if(!ti)
			{
				if(!strcmp(GID,""))
				mainTree->InsertGroup(FID,(int)state[0]);
				else
				{
					mainTree->InsertGroup(GID,3);
					mainTree->InsertChild(GID,FID,(int)state[0]);
				}
			}else
			{
				mainTree->ModifyChild(ti,(int)state[0]);
			}
		}
		break;
		
	//ڽ  ....
	case OSPP_ECHO:
		int index;
		char msg[70];
		char temp[72];
		Pack->GetField(0,msg);
		strcpy(temp," : ");
		strcat(temp,msg);
		dlg_Debug_Log_Show(temp);
		Session.findSession(Pack->GetDLG_ID(),sr);
		index=SendMessage(sr.hChatList,LB_ADDSTRING,0,(LPARAM)temp);
		SendMessage(sr.hChatList,LB_SETTOPINDEX,index,0);
		break;

	//ä 
	case OSPP_CHTS: 

		int chtsIndex;
		char chtsFID[10];
		char chtsFnum[2];
		char chtsmsg[70];
		char chtsdata[75];
		int myDlgnum;
		Pack->GetField(0,chtsFID);
		Pack->GetField(1,chtsFnum);
		Pack->GetField(2,chtsmsg);
		myDlgnum=Pack->GetDLG_ID();


		// ȭâ ѹ ߸Ǿ => 밡 ȭɶ
		if(myDlgnum!=dlg_Chat_myDlgNum(chtsFID))
		{
			Session.findSession(chtsFID,csr);
			csr.fdDlgID=(int)chtsFnum[0];
			Session.modifySession(csr.myDlgID,csr);
			if(!IsWindow(csr.hCDlg))
			SendMessage(hWnd,601,0,csr.myDlgID);
		}
		else
		{
			strcpy(csr.FID,chtsFID);
		}

		if(Session.findSession(csr.FID,csr)==2)
		{
		strcpy(chtsdata,chtsFID);
		strcat(chtsdata," : ");
		strcat(chtsdata,chtsmsg);
		chtsIndex=SendMessage(csr.hChatList,LB_ADDSTRING,0,(LPARAM)chtsdata);
		SendMessage(csr.hChatList,LB_SETTOPINDEX,chtsIndex,0);
		}

		break;
/////////////////////// Add Friend request ////////////////////////////////
	case OSPP_ADOK:
		GetDlgItemText(hAddFidDlg,IDC_ADD_FID,AddData,10);
		strcat(AddData," ߰Ǿϴ.");
		SetDlgItemText(hAddFidDlg,IDC_ADD_FID_EDIT,AddData);
		SetDlgItemText(hAddFidDlg,IDC_ADD_FID,"");
		break;
	case OSPP_ADNO:
		GetDlgItemText(hAddFidDlg,IDC_ADD_FID,AddData,10);
		strcat(AddData," ߰ϴµ ߽ϴ.");
		SetDlgItemText(hAddFidDlg,IDC_ADD_FID_EDIT,AddData);
		SetDlgItemText(hAddFidDlg,IDC_ADD_FID,"");
		break;
/////////////////////// Del Friend request ////////////////////////////////
	case OSPP_DEOK:
		SetDlgItemText(hDelFidDlg,IDC_DEL_FID," Ǿϴ.");
		mainTree->DeleteChild(this->DeletedFriend);
		strcpy(DeletedFriend,"");
		break;
	case OSPP_DENO:
		SetDlgItemText(hDelFidDlg,IDC_DEL_FID,"ϴµ ߽ϴ.");
		break;
	}
}

//////////////////////////////////////////////////////////
//	Send func
void khosMain::net_SendData(int type)
{
	net_PacketBuild(type);
	net_Send();
	ospbuf.ClearAll();
}
void khosMain::net_SendData(int type,Session_Record sr,char * data)
{
	net_PacketBuild(type,sr,data);
	net_Send();
	ospbuf.ClearAll();
}

void khosMain::net_Send()
{
	char Sdata[100];
	int byte=send(ospSock.sock,
		ospbuf.GetPacketStream(),ospbuf.GetPacketSize(),0);
	if(byte==-1) Error("Send Error");
	
	wsprintf(Sdata,"Send Byte : %d",byte);
	dlg_Debug_SendData_Show(Sdata);

	wsprintf(Sdata,"Packet Byte : %d",ospbuf.GetPacketSize());
	dlg_Debug_SendData_Show(Sdata);
}

void khosMain::net_Send(char * Senddata)
{
	char Sdata[100];
	int byte=send(ospSock.sock,
		Senddata,strlen(Senddata),0);
	if(byte==-1) Error("Send Error");
	
	wsprintf(Sdata,"Send Byte : %d",byte);
	dlg_Debug_SendData_Show(Sdata);

	wsprintf(Sdata,"Packet Byte : %d",strlen(Senddata));
	dlg_Debug_SendData_Show(Sdata);

	dlg_Debug_SendData_Show(Senddata);
}

void khosMain::net_PacketBuild(int type)
{
	switch(type)
	{
	case AUTH:
		GetDlgItemText(hLogInDlg,IDC_USER_ID,
			ospSock.ID,SID_SIZE);
		GetDlgItemText(hLogInDlg,IDC_USER_PASSWD,
			ospSock.passwd,SPW_SIZE);
		ospbuf.InsertQR_Type(OSPP_AUTH);
		ospbuf.InsertDLG_ID(1);
		ospbuf.AppendField(ospSock.ID);
		ospbuf.AppendField(ospSock.passwd);
		break;
	case FLRQ:
		ospbuf.InsertQR_Type(OSPP_FLRQ);
		ospbuf.InsertDLG_ID(0);
		break;

	}
}

void khosMain::net_PacketBuild(int type,Session_Record sr,char * data)
{
	switch(type)
	{
	case CHTC:
		ospbuf.InsertQR_Type(OSPP_CHTC);
		ospbuf.InsertDLG_ID(sr.myDlgID);
			dlg_Debug_Log_Show(sr.FID);
		ospbuf.AppendField(sr.FID);
		ospbuf.AppendField(sr.fdDlgID);
			dlg_Debug_Log_Show(data);
		ospbuf.AppendField(data);
		break;
	case ADDF:
		ospbuf.InsertQR_Type(OSPP_ADDF);
		ospbuf.AppendField(data);
		break;
	case DELF:
		ospbuf.InsertQR_Type(OSPP_DELF);
		ospbuf.AppendField(data);
		break;
	}
}

//////////////////////////////////////////////////////////
//	Get func
void khosMain::Get_User_Name(char *name)
{
	strcpy(name,ospSock.ID);
}
