
#include "../osp_mClass.h"
#include <windows.h>
#include <windowsx.h>
#include "../osp_global.h"


void mainTreeTest()
{
	char group[100];
	char child[100];

	for(int i=0;i<10;i++)
	{
		wsprintf(group,"Group%d",i+1000);

		khos.mainTree->InsertGroup(group);
		for(int j=0;j<10;j++)
		{
			wsprintf(child,"Friend%d",j+1000);
			khos.mainTree->InsertChild(group,child);
		}		
	}
}

void SessionTest()
{
	Session_Record sr;
	
	char FID[10];

	for(int i=0;i<100;i++)
	{
		wsprintf(FID,"FID%d",i+100);
		strcpy(sr.FID,FID);
		sr.fdDlgID=100+i;
		sr.hCDlg=(HWND)i;
		sr.myDlgID=10+i;
		khos.Session.insertSession(sr);
	}
}

void ErrorHandling(char *message)
{
	MessageBox(g_hwnd,message,"error",MB_OK);
	exit(1);
}


BOOL CenterWindow(HWND hwndChild, HWND hwndParent)
{
    RECT    rcChild, rcParent;
    int     cxChild, cyChild, cxParent, cyParent;
    int     cxScreen, cyScreen, xNew, yNew;
    HDC     hdc;

    // Get the Height and Width of the child window
    GetWindowRect(hwndChild, &rcChild);
    cxChild = rcChild.right - rcChild.left;
    cyChild = rcChild.bottom - rcChild.top;

    // Get the Height and Width of the parent window
    GetWindowRect(hwndParent, &rcParent);
    cxParent = rcParent.right - rcParent.left;
    cyParent = rcParent.bottom - rcParent.top;

    // Get the display limits
    hdc = GetDC(hwndChild);
    cxScreen = GetDeviceCaps(hdc, HORZRES);
    cyScreen = GetDeviceCaps(hdc, VERTRES);
    ReleaseDC(hwndChild, hdc);

    // Calculate new X position, then adjust for screen
    xNew = rcParent.left + ((cxParent - cxChild) / 2);
    if (xNew < 0)
    {
        xNew = 0;
    }
    else if ((xNew + cxChild) > cxScreen)
    {
        xNew = cxScreen - cxChild;
    }

    // Calculate new Y position, then adjust for screen
    yNew = rcParent.top  + ((cyParent - cyChild) / 2);
    if (yNew < 0)
    {
        yNew = 0;
    }
    else if ((yNew + cyChild) > cyScreen)
    {
        yNew = cyScreen - cyChild;
    }

    // Set it, and return
    return SetWindowPos(hwndChild,
                        NULL,
                        xNew, yNew,
                        0, 0,
                        SWP_NOSIZE | SWP_NOZORDER);
}

