
#ifndef JID_H
#define JID_H

#include "common.h"
//#include "JaguarX.h"

namespace JaguarX
{


class JID 
{
public:
	static string getResource(const string& jid);
	static string getUserHost(const string& jid);	    
	static string getHost(const string& jid);
	static string getUser(const string& jid);
	static bool isValidUser(const string& user);
	static bool isValidHost(const string& host);
	static int compare(const string& ljid, const string& rjid);

	struct Compare {
		bool operator()(const string& lhs, const string& rhs) const;
	};
};

}//end of JaguarX namespace

#endif